// I hate unicode!!! :WAAH:

use std::io::{Cursor, Write};

use bstr::{BStr, ByteSlice, CharIndices};
use serde_json::ser::{CharEscape, CompactFormatter, Formatter};

pub struct CharEscaper<'a>(CharIndices<'a>, &'a [u8]);

impl<'a> CharEscaper<'a> {
  pub fn new(src: &'a [u8]) -> Self {
    let bstr = BStr::new(src);
    Self(bstr.char_indices(), src)
  }

  pub fn to_string(self) -> String {
    let s = Vec::new();
    let mut c = Cursor::new(s);
    let mut f = CompactFormatter;
    for ch in self {
      match ch {
        Ok(ch) => {
          write!(c, "{ch}").unwrap();
        }
        Err((c0, c1, c2)) => {
          f.write_char_escape(&mut c, c0).unwrap();
          if let Some(c1) = c1 {
            f.write_char_escape(&mut c, c1).unwrap();
          }
          if let Some(c2) = c2 {
            f.write_char_escape(&mut c, c2).unwrap();
          }
        }
      }
    }
    let s = c.into_inner();
    String::from_utf8(s).unwrap()
  }
}

impl<'a> Iterator for CharEscaper<'a> {
  type Item =
    Result<char, (CharEscape, Option<CharEscape>, Option<CharEscape>)>;

  fn next(&mut self) -> Option<Self::Item> {
    let (start, end, ch) = match self.0.next() {
      Some(v) => v,
      None => return None,
    };

    let mut c1 = None;
    let mut c2 = None;

    let c0 = match ch {
      '"' => CharEscape::Quote,
      '\\' => CharEscape::ReverseSolidus,
      '/' => CharEscape::Solidus,
      '\u{0008}' => CharEscape::Backspace,
      '\u{000c}' => CharEscape::FormFeed,
      '\u{000a}' => CharEscape::LineFeed,
      '\u{000d}' => CharEscape::CarriageReturn,
      '\u{0009}' => CharEscape::Tab,
      '\u{fffd}' => {
        let c0 = CharEscape::AsciiControl(self.1[start]);
        if end - start > 1 {
          c1 = Some(CharEscape::AsciiControl(self.1[start + 1]));
        }
        if end - start > 2 {
          c2 = Some(CharEscape::AsciiControl(self.1[start + 2]));
        }
        c0
      }
      _ => return Some(Ok(ch)),
    };

    Some(Err((c0, c1, c2)))
  }
}
